Package org.apache.commons.collections4.map

# Class CompositeMap<K,V>

java.lang.Object
org.apache.commons.collections4.map.AbstractIterableMap<K,V>
org.apache.commons.collections4.map.CompositeMap<K,V>

Type Parameters:
  `K` - the type of the keys in this map
  `V` - the type of the values in this map

All Implemented Interfaces:
  `Serializable`, `Map<K,V>`, `Get<K,V>`, `IterableGet<K,V>`, `IterableMap<K,V>`, `Put<K,V>`

public class CompositeMap<K,V> extends AbstractIterableMap<K,V> implements Serializable
Decorates a map of other maps to provide a single unified view.

Changes made to this map will actually be made on the decorated map. Add and remove operations require the use of a pluggable strategy. If no strategy is provided then add and remove are unsupported.

Note that CompositeMap is not synchronized and is not thread-safe. If you wish to use this map from multiple threads concurrently, you must use appropriate synchronization. The simplest approach is to wrap this map using `Collections.synchronizedMap(Map)`. This class may throw exceptions when accessed by concurrent threads without synchronization.

Since:
  3.0
See Also:
  - Serialized Form

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static interface`
  `CompositeMap.MapMutator<K,V>`
  This interface allows definition for all of the indeterminate mutators in a CompositeMap, as well as providing a hook for callbacks on key collisions.

  ## Nested classes/interfaces inherited from interface java.util.Map

  `Map.Entry<K extends Object,V extends Object>`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CompositeMap()`
  Create a new, empty, CompositeMap.
  `CompositeMap(Map<K,V>... composite)`
  Create a new CompositeMap which composites all of the Map instances in the argument.
  `CompositeMap(Map<K,V>[] composite, CompositeMap.MapMutator<K,V> mutator)`
  Create a new CompositeMap which composites all of the Map instances in the argument.
  `CompositeMap(Map<K,V> one, Map<K,V> two)`
  Create a new CompositeMap with two composited Map instances.
  `CompositeMap(Map<K,V> one, Map<K,V> two, CompositeMap.MapMutator<K,V> mutator)`
  Create a new CompositeMap with two composited Map instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addComposited(Map<K,V> map)`
  Add an additional Map to the composite.
  `void`
  `clear()`
  Calls `clear()` on all composited Maps.
  `boolean`
  `containsKey(Object key)`
  Returns `true` if this map contains a mapping for the specified key.
  `boolean`
  `containsValue(Object value)`
  Returns `true` if this map maps one or more keys to the specified value.
  `Set<Map.Entry<K,V>>`
  `entrySet()`
  Returns a set view of the mappings contained in this map.
  `boolean`
  `equals(Object obj)`
  Checks if this Map equals another as per the Map specification.
  `V`
  `get(Object key)`
  Returns the value to which this map maps the specified key.
  `int`
  `hashCode()`
  Gets a hash code for the Map as per the Map specification.
  `boolean`
  `isEmpty()`
  Returns `true` if this map contains no key-value mappings.
  `Set<K>`
  `keySet()`
  Returns a set view of the keys contained in this map.
  `V`
  `put(K key, V value)`
  Associates the specified value with the specified key in this map (optional operation).
  `void`
  `putAll(Map<? extends K,? extends V> map)`
  Copies all of the mappings from the specified map to this map (optional operation).
  `V`
  `remove(Object key)`
  Removes the mapping for this key from this map if it is present (optional operation).
  `Map<K,V>`
  `removeComposited(Map<K,V> map)`
  Remove a Map from the composite.
  `void`
  `setMutator(CompositeMap.MapMutator<K,V> mutator)`
  Specify the MapMutator to be used by mutation operations.
  `int`
  `size()`
  Returns the number of key-value mappings in this map.
  `Collection<V>`
  `values()`
  Returns a collection view of the values contained in this map.

  ### Methods inherited from class org.apache.commons.collections4.map.AbstractIterableMap

  `mapIterator`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface java.util.Map

  `compute, computeIfAbsent, computeIfPresent, forEach, getOrDefault, merge, putIfAbsent, remove, replace, replace, replaceAll`

- ## Constructor Details

  - ### CompositeMap

    public CompositeMap()
    Create a new, empty, CompositeMap.

  - ### CompositeMap

    public CompositeMap(Map<K,V>... composite)
    Create a new CompositeMap which composites all of the Map instances in the argument. It copies the argument array, it does not use it directly.
    Parameters:
      `composite` - the Maps to be composited
    Throws:
      `IllegalArgumentException` - if there is a key collision

  - ### CompositeMap

    public CompositeMap(Map<K,V> one, Map<K,V> two)
    Create a new CompositeMap with two composited Map instances.
    Parameters:
      `one` - the first Map to be composited
      `two` - the second Map to be composited
    Throws:
      `IllegalArgumentException` - if there is a key collision

  - ### CompositeMap

    public CompositeMap(Map<K,V> one, Map<K,V> two, CompositeMap.MapMutator<K,V> mutator)
    Create a new CompositeMap with two composited Map instances.
    Parameters:
      `one` - the first Map to be composited
      `two` - the second Map to be composited
      `mutator` - MapMutator to be used for mutation operations

  - ### CompositeMap

    public CompositeMap(Map<K,V>[] composite, CompositeMap.MapMutator<K,V> mutator)
    Create a new CompositeMap which composites all of the Map instances in the argument. It copies the argument array, it does not use it directly.
    Parameters:
      `composite` - Maps to be composited
      `mutator` - MapMutator to be used for mutation operations

- ## Method Details

  - ### addComposited

    public void addComposited(Map<K,V> map) throws IllegalArgumentException
    Add an additional Map to the composite.
    Parameters:
      `map` - the Map to be added to the composite
    Throws:
      `IllegalArgumentException` - if there is a key collision and there is no MapMutator set to handle it.

  - ### clear

    public void clear()
    Calls `clear()` on all composited Maps.
    Specified by:
      `clear` in interface `Map<K,V>`
    Specified by:
      `clear` in interface `Put<K,V>`
    Throws:
      `UnsupportedOperationException` - if any of the composited Maps do not support clear()
    See Also:
      - `Map.clear()`

  - ### containsKey

    public boolean containsKey(Object key)
    Returns `true` if this map contains a mapping for the specified key. More formally, returns `true` if and only if this map contains at a mapping for a key `k` such that `(key==null ? k==null : key.equals(k))`. (There can be at most one such mapping.)
    Specified by:
      `containsKey` in interface `Get<K,V>`
    Specified by:
      `containsKey` in interface `Map<K,V>`
    Parameters:
      `key` - key whose presence in this map is to be tested.
    Returns:
      `true` if this map contains a mapping for the specified key.
    Throws:
      `ClassCastException` - if the key is of an inappropriate type for this map (optional).
      `NullPointerException` - if the key is `null` and this map does not permit `null` keys (optional).
    See Also:
      - `Map.containsKey(Object)`

  - ### containsValue

    public boolean containsValue(Object value)
    Returns `true` if this map maps one or more keys to the specified value. More formally, returns `true` if and only if this map contains at least one mapping to a value `v` such that `(value==null ? v==null : value.equals(v))`. This operation will probably require time linear in the map size for most implementations of the `Map` interface.
    Specified by:
      `containsValue` in interface `Get<K,V>`
    Specified by:
      `containsValue` in interface `Map<K,V>`
    Parameters:
      `value` - value whose presence in this map is to be tested.
    Returns:
      `true` if this map maps one or more keys to the specified value.
    Throws:
      `ClassCastException` - if the value is of an inappropriate type for this map (optional).
      `NullPointerException` - if the value is `null` and this map does not permit `null` values (optional).
    See Also:
      - `Map.containsValue(Object)`

  - ### entrySet

    public Set<Map.Entry<K,V>> entrySet()
    Returns a set view of the mappings contained in this map. Each element in the returned set is a `Map.Entry`. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. If the map is modified while an iteration over the set is in progress, the results of the iteration are undefined. The set supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll` and `clear` operations. It does not support the `add` or `addAll` operations.

    This implementation returns a `CompositeSet` which composites the entry sets from all of the composited maps.

    Specified by:
      `entrySet` in interface `Get<K,V>`
    Specified by:
      `entrySet` in interface `Map<K,V>`
    Returns:
      a set view of the mappings contained in this map.
    See Also:
      - `CompositeSet`

  - ### equals

    public boolean equals(Object obj)
    Checks if this Map equals another as per the Map specification.
    Specified by:
      `equals` in interface `Map<K,V>`
    Overrides:
      `equals` in class `Object`
    Parameters:
      `obj` - the object to compare to
    Returns:
      true if the maps are equal

  - ### get

    public V get(Object key)
    Returns the value to which this map maps the specified key. Returns `null` if the map contains no mapping for this key. A return value of `null` does not necessarily indicate that the map contains no mapping for the key; it's also possible that the map explicitly maps the key to `null`. The `containsKey` operation may be used to distinguish these two cases.

    More formally, if this map contains a mapping from a key `k` to a value `v` such that `(key==null ? k==null : key.equals(k))`, then this method returns `v`; otherwise it returns `null`. (There can be at most one such mapping.)

    Specified by:
      `get` in interface `Get<K,V>`
    Specified by:
      `get` in interface `Map<K,V>`
    Parameters:
      `key` - key whose associated value is to be returned.
    Returns:
      the value to which this map maps the specified key, or `null` if the map contains no mapping for this key.
    Throws:
      `ClassCastException` - if the key is of an inappropriate type for this map (optional).
      `NullPointerException` - key is `null` and this map does not permit `null` keys (optional).
    See Also:
      - `containsKey(Object)`

  - ### hashCode

    public int hashCode()
    Gets a hash code for the Map as per the Map specification.
    Specified by:
      `hashCode` in interface `Map<K,V>`
    Overrides:
      `hashCode` in class `Object`

  - ### isEmpty

    public boolean isEmpty()
    Returns `true` if this map contains no key-value mappings.
    Specified by:
      `isEmpty` in interface `Get<K,V>`
    Specified by:
      `isEmpty` in interface `Map<K,V>`
    Returns:
      `true` if this map contains no key-value mappings.
    See Also:
      - `Map.isEmpty()`

  - ### keySet

    public Set<K> keySet()
    Returns a set view of the keys contained in this map. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. If the map is modified while an iteration over the set is in progress, the results of the iteration are undefined. The set supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Set.remove`, `removeAll` `retainAll`, and `clear` operations. It does not support the add or `addAll` operations.

    This implementation returns a `CompositeSet` which composites the key sets from all of the composited maps.

    Specified by:
      `keySet` in interface `Get<K,V>`
    Specified by:
      `keySet` in interface `Map<K,V>`
    Returns:
      a set view of the keys contained in this map.
    See Also:
      - `Map.keySet()`

  - ### put

    public V put(K key, V value)
    Associates the specified value with the specified key in this map (optional operation). If the map previously contained a mapping for this key, the old value is replaced by the specified value. (A map `m` is said to contain a mapping for a key `k` if and only if `m.containsKey(k)` would return `true`.))
    Specified by:
      `put` in interface `Map<K,V>`
    Specified by:
      `put` in interface `Put<K,V>`
    Parameters:
      `key` - key with which the specified value is to be associated.
      `value` - value to be associated with the specified key.
    Returns:
      previous value associated with specified key, or `null` if there was no mapping for key. A `null` return can also indicate that the map previously associated `null` with the specified key, if the implementation supports `null` values.
    Throws:
      `UnsupportedOperationException` - if no MapMutator has been specified
      `ClassCastException` - if the class of the specified key or value prevents it from being stored in this map.
      `IllegalArgumentException` - if some aspect of this key or value prevents it from being stored in this map.
      `NullPointerException` - this map does not permit `null` keys or values, and the specified key or value is `null`.
    See Also:
      - `Map.put(Object, Object)`

  - ### putAll

    public void putAll(Map<? extends K,? extends V> map)
    Copies all of the mappings from the specified map to this map (optional operation). The effect of this call is equivalent to that of calling `put(k, v)` on this map once for each mapping from key `k` to value `v` in the specified map. The behavior of this operation is unspecified if the specified map is modified while the operation is in progress.
    Specified by:
      `putAll` in interface `Map<K,V>`
    Specified by:
      `putAll` in interface `Put<K,V>`
    Parameters:
      `map` - Mappings to be stored in this map.
    Throws:
      `UnsupportedOperationException` - if the `putAll` method is not supported by this map.
      `ClassCastException` - if the class of a key or value in the specified map prevents it from being stored in this map.
      `IllegalArgumentException` - some aspect of a key or value in the specified map prevents it from being stored in this map.
      `NullPointerException` - the specified map is `null`, or if this map does not permit `null` keys or values, and the specified map contains `null` keys or values.
    See Also:
      - `Map.putAll(Map)`

  - ### remove

    public V remove(Object key)
    Removes the mapping for this key from this map if it is present (optional operation). More formally, if this map contains a mapping from key `k` to value `v` such that `(key==null ? k==null : key.equals(k))`, that mapping is removed. (The map can contain at most one such mapping.)

    Returns the value to which the map previously associated the key, or `null` if the map contained no mapping for this key. (A `null` return can also indicate that the map previously associated `null` with the specified key if the implementation supports `null` values.) The map will not contain a mapping for the specified key once the call returns.

    Specified by:
      `remove` in interface `Get<K,V>`
    Specified by:
      `remove` in interface `Map<K,V>`
    Parameters:
      `key` - key whose mapping is to be removed from the map.
    Returns:
      previous value associated with specified key, or `null` if there was no mapping for key.
    Throws:
      `ClassCastException` - if the key is of an inappropriate type for the composited map (optional).
      `NullPointerException` - if the key is `null` and the composited map does not permit `null` keys (optional).
      `UnsupportedOperationException` - if the `remove` method is not supported by the composited map containing the key
    See Also:
      - `Map.remove(Object)`

  - ### removeComposited

    public Map<K,V> removeComposited(Map<K,V> map)
    Remove a Map from the composite.
    Parameters:
      `map` - the Map to be removed from the composite
    Returns:
      The removed Map or `null` if map is not in the composite

  - ### setMutator

    public void setMutator(CompositeMap.MapMutator<K,V> mutator)
    Specify the MapMutator to be used by mutation operations.
    Parameters:
      `mutator` - the MapMutator to be used for mutation delegation

  - ### size

    public int size()
    Returns the number of key-value mappings in this map. If the map contains more than `Integer.MAX_VALUE` elements, returns `Integer.MAX_VALUE`.
    Specified by:
      `size` in interface `Get<K,V>`
    Specified by:
      `size` in interface `Map<K,V>`
    Returns:
      the number of key-value mappings in this map.
    See Also:
      - `Map.size()`

  - ### values

    public Collection<V> values()
    Returns a collection view of the values contained in this map. The collection is backed by the map, so changes to the map are reflected in the collection, and vice-versa. If the map is modified while an iteration over the collection is in progress, the results of the iteration are undefined. The collection supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Collection.remove`, `removeAll`, `retainAll` and `clear` operations. It does not support the add or `addAll` operations.
    Specified by:
      `values` in interface `Get<K,V>`
    Specified by:
      `values` in interface `Map<K,V>`
    Returns:
      a collection view of the values contained in this map.
    See Also:
      - `Map.values()`